Advisory Details

October 2nd, 2018

(0Day) Wecon PIStudio basedll TextContent Stack-based Buffer Overflow Remote Code Execution Vulnerability

ZDI-18-1109
ZDI-CAN-6253

CVE ID
CVSS SCORE 9.3, (AV:N/AC:M/Au:N/C:C/I:C/A:C)
AFFECTED VENDORS Wecon
AFFECTED PRODUCTS PIStudio
VULNERABILITY DETAILS


This vulnerability allows remote attackers to execute arbitrary code on vulnerable installations of Wecon PIStudio. User interaction is required to exploit this vulnerability in that the target must visit a malicious page or open a malicious file.

The specific flaw exists within the handling of hsc files. When parsing the TextContent element, the process does not properly validate the length of user-supplied data prior to copying it to a fixed-length stack-based buffer. An attacker can leverage this vulnerability to execute code under the context of an administrator.

ADDITIONAL DETAILS


This vulnerability is being disclosed publicly without a patch in accordance with the ZDI 120 day deadline.

05/18/18 - ZDI sent the report to ICS-CERT
05/22/18 - ICS-CERT acknowledged, confirmed the report was sent to the vendor and sent an ICS-VU #
09/17/18 - ZDI asked ICS-CERT to confirm the report remains unpatched and to advise the vendor of the intent to publish the report as 0-day on 10/02/18

-- Mitigation:
Given the nature of the vulnerability the only salient mitigation strategy is to restrict interaction with the application to trusted files.


DISCLOSURE TIMELINE
  • 2018-05-18 - Vulnerability reported to vendor
  • 2018-10-02 - Coordinated public release of advisory
  • 2018-10-02 - Advisory Updated
CREDIT Natnael Samson(Natti)
BACK TO ADVISORIES